#pragma once
#ifndef PARSODUS_INPUT_PARSER_H 
#define PARSODUS_INPUT_PARSER_H

#include <istream>
#include "Parsodus/config.h"
#include "ParsodusLexer.h"

namespace pds {

    class InputParser {
        public:

            static Config parseInput(std::istream& is);
            
        private:
            static void lexColon(ParsodusLexer& lex, ParsodusLexer::Token &token, bool nextoken = true);
    };
    
    /**
     * Used to throw errors when the inputfile was not valid
     */

    class InputParserException: public std::exception {
    public:
        InputParserException(std::string what);
        virtual const char* what() const throw();

    private:
        std::string m_what;
    };
}

#endif // PARSODUS_INPUT_PARSER_H
